#!/usr/bin/env python
# -*- coding: utf-8 -*-
# File name: hanconv.py

def getlistfromfile(filename):
	result = [[],[]]
	for line in file(filename).read().rsplit('\n'):
		if line.find('\t') == -1:continue
		if not -1 == line.find('#'):continue 
		if not -1 == line.find('?'):continue
		splited = line.rsplit('\t')
		if len(splited) in (0, 1):continue
		if len(splited[0]) == 0 or len(splited[1]) == 0:continue
		result[0].append(splited[0])
		result[1].append(splited[1])
	return result

def getlistfromfilenames(filenames):
	result = [[],[]]
	for filename in filenames:
		l = getlistfromfile(filename)
		for n in range(0, len(l[0])):
			result[0].append(l[0][n])
			result[1].append(l[1][n])
	return result

def getlistfrommode(mode):
	mode = str(mode)
	global getlistfrommodecache, getlistfrommodelastmode
	if getlistfrommodecacheenable == True:
		if getlistfrommodelastmode == mode:
			result = getlistfrommodecache
		else:
			getlistfrommodelastmode = mode
			result = getlistfromfilenames(modes[mode])
			getlistfrommodecache = result
	else:
		result = getlistfromfilenames(modes[mode])
	return result

def getlenoflistfrommode(mode):
	mode = str(mode)
	return len(getlistfrommode(mode)[0])

def printlistfrommode(mode):
	mode = str(mode)
	modelist = getlistfrommode(mode)
	for n in range(0, len(modelist[0])):
		print modelist[0][n]+'\t'+modelist[1][n]

def convert(text = '', mode = 'unionly', reverse=False):
	convlist = getlistfrommode(str(mode))
	for n in range(0, len(convlist[0])):
		if reverse == True:
			text = text.replace(convlist[1][n], convlist[0][n])
		else:
			text = text.replace(convlist[0][n], convlist[1][n])
	return text

def initmodes():
	global modes
	#Set default modes
	modes['unionly'] = ['dic0.txt', 'dic4.txt', 'dic5.txt', 'dic1.txt']
	modes['uniandcomp'] = ['dic3.txt', 'dic2.txt']
	modes['withoutduuem'] = ['dic0.txt', 'dic1.txt']
	modes['uninormal'] = ['dic0.txt']
	modes['compboth'] = ['dic4.txt', 'dic3.txt', 'dic2.txt']
	modes['hangul2hanja'] = ['dic6.txt']

	#Alternative mode names
	modes['1'] = modes['unionly']
	modes['2'] = modes['uniandcomp']
	modes['3'] = modes['withoutduuem']
	modes['4'] = modes['uninormal']
	modes['5'] = modes['compboth']
	modes['6'] = modes['hangul2hanja']

getlistfrommodecacheenable = True
getlistfrommodecache = ''
getlistfrommodelastmode = ''

modes = {}
initmodes()




