#!/usr/bin/env python
# -*- coding: utf-8 -*-
# File name: hanja.py
import sys
import hanconv

#Definitions
def preface(): #Print Preface
	print 'Hanja Hangul Converter 0.0.5    by Sung-il KIM (masoris@gmail.com)'
	print 'Commands: exit(종료), mode(방식), reverse(역변환), list(목록)'
	print 'Type hanja to convert and press enter.'

def command(cmd): #Analyzing Command and Get Result
	global looping, reverse

	#Commands
	if cmd.lower() in ('exit','종료'):
		looping = False
		return
	elif cmd.lower() in ('list', '목록'):
		hanconv.printlistfrommode(mode)
	elif cmd.lower() in ('reverse', '정변환', '역변환'):
		if(reverse == True):
			reverse = False
			print 'Convert Hanja to Hangul'
			return
		elif(reverse == False):
			reverse = True
			print 'Convert Hangul to Hanja (Reverse)'
			return
	elif cmd.lower() in ('mode', '방식', '모드'):
		setmode()
		print ''
		preface()
		return

	#Convert
	print '出'+str(times)+'> '+convert(cmd)

def convert(txt): #Convert Hanja to Hangul
	return hanconv.convert(txt, mode, reverse)

def setmode(mod="-1"):
	global mode

	#Select Mode
	if(mod == "-1"):
		print 'Choose mode to convert Hanja to Hangul'
		print '1. Han unification only (Wikipedia, default)'
		print '2. Han unification and CJK Compatibility Forms (MS Word)'
		print '3. Without duuembeobchik (North Korean)'
		print '4. Apply Unicode normalization algorithm'
		print '5. (experiment) Compatible convert with both ways (1, 2)'
		print '6. (experiment) Convert Hangul to Hanja'
		mod = raw_input('擇> ')
	
	mod = str(mod)
	if mod in hanconv.modes:
		mode = mod
	else:
		mode = '1'

	if(message):
		print 'Mode '+mode+' Selected'
		print 'Total '+str(hanconv.getlenoflistfrommode(mode))+' of indexes'


#Set Variations
looping = True
times = 0 #The number of looping times
reverse = False #Reverse Converting
message = False #Print Message
mode = '1' #Current Mode
arginput = ''

	
#Start Programme
#Arguments Start
#Is argv1 is text to convert or a filename?
if(len(sys.argv)>=2):
	try:
		arginput = file(sys.argv[1]).read()		
	except:
		arginput = sys.argv[1]

#Convert argv1 and print result
if(len(sys.argv)==2):
	print hanconv.convert(arginput)

#Convert argv1 by argv2 mode and print result
elif(len(sys.argv)==3):
	print hanconv.convert(arginput,sys.argv[2])

#Convert argv1 by argv2 mode and save result to argv3 file
elif(len(sys.argv)==4):
	file(sys.argv[3], 'w').write(hanconv.convert(arginput,sys.argv[2]))

#Start looping
else:
	message = True
	preface()
	print ''
	setmode()
	
	while(looping):
		times = times + 1
		command(str(raw_input('\n入'+str(times)+'> ')))
#End Programme

